unit Customers;
interface
uses
  Data.DB;

type
  TCustomer = class
  private
    FCustomerID: String;
    FCompanyName: String;
    FContactName: String;
    FContactTitle: String;
    FAddress: String;
    FCity: String;
    FRegion: String;
    FPostalCode: String;
    FCountry: String;
    FPhone: String;
    FFax: String;
  public
    procedure Read(DS: TDataSet);
  end;

  TCustomers = class
  public
    Customers: array of TCustomer;
  public
    procedure Read(DS: TDataSet);
    destructor Destroy; override;
    function ToJSON: String;
  end;

implementation
uses
  REST.Json;

{ TEmployee }

procedure TCustomer.Read(DS: TDataSet);
begin
  FCustomerID := DS.FieldByName('CustomerID').AsString;
  FCompanyName := DS.FieldByName('CompanyName').AsString;
  FContactName := DS.FieldByName('ContactName').AsString;
  FContactTitle := DS.FieldByName('ContactTitle').AsString;
  FAddress := DS.FieldByName('Address').AsString;
  FCity := DS.FieldByName('City').AsString;
  FRegion := DS.FieldByName('Region').AsString;
  FPostalCode := DS.FieldByName('PostalCode').AsString;
  FCountry := DS.FieldByName('Country').AsString;
  FPhone := DS.FieldByName('Phone').AsString;
  FFax := DS.FieldByName('Fax').AsString;
end;

{ TCustomers }

procedure TCustomers.Read(DS: TDataSet);
var
  i: Integer;
begin
  SetLength(Customers, DS.RecordCount);
  DS.First;
  i := 0;
  while not DS.Eof do
  begin
    Customers[i] := TCustomer.Create;
    Customers[i].Read(DS);
    Inc(i);
    DS.Next;
  end;
end;

destructor TCustomers.Destroy;
var
  i: Integer;
begin
  for i:=High(Customers) downto 0 do Customers[i].Free;
  Customers := nil;
  inherited;
end;

function TCustomers.ToJSON: String;
begin
  Result := TJson.ObjectToJsonString(Self)
end;

end.

