unit SpaForm;
interface
uses
  System.SysUtils, System.Classes, WEBLib.Graphics, WEBLib.Forms, WEBLib.Dialogs, WEBLib.CDS, Vcl.Controls, WEBLib.Controls,
  WEBLib.DBCtrls, Data.DB, Datasnap.DBClient, Vcl.StdCtrls, WEBLib.StdCtrls, WEBLib.REST;

type
  TFormEmsDemo = class(TWebForm)
    WebClientConnection1: TWebClientConnection;
    WebClientDataSet1: TWebClientDataSet;
    WebClientDataSource1: TWebClientDataSource;
    WebDBNavigator1: TWebDBNavigator;
    edCompanyName: TWebDBEdit;
    edContactName: TWebDBEdit;
    WebButton1: TWebButton;
    lbCustomerID: TWebDBLabel;
    WebMemo1: TWebMemo;
    WebHttpRequest1: TWebHttpRequest;
    procedure WebButton1Click(Sender: TObject);
    procedure WebClientConnection1AfterConnect(Sender: TObject);
    procedure WebClientConnection1BeforeConnect(Sender: TObject);
    procedure WebClientConnection1ConnectError(Sender: TObject; ErrorCode: Integer);
    procedure WebClientDataSource1DataChange(Sender: TObject; Field: TField);
    procedure WebClientDataSource1StateChange(Sender: TObject);
    procedure WebClientDataSource1UpdateData(Sender: TObject);
    procedure WebFormCreate(Sender: TObject);
  protected
    TableUpdating: Boolean;
  end;

var
  FormEmsDemo: TFormEmsDemo;

implementation

{$R *.dfm}

procedure TFormEmsDemo.WebFormCreate(Sender: TObject);
begin
  TableUpdating := False;
end;

procedure TFormEmsDemo.WebButton1Click(Sender: TObject);
begin
  WebMemo1.Lines.Clear;
  try
    WebClientConnection1.Active := False;
    WebClientDataSet1.Close;
    WebClientConnection1.URI := 'https://www.bobswart.nl/ems/emsserver.dll/WebCoreEMS';
    WebClientConnection1.URI := 'http://localhost:8080/WebCoreEMS'; // local test
    WebClientConnection1.DataNode := 'customers';
    WebClientDataSet1.FieldDefs.Clear;
    WebClientDataSet1.FieldDefs.Add('customerID',ftstring,5); // case sensitive
    WebClientDataSet1.FieldDefs.Add('companyName',ftstring,40);
    WebClientDataSet1.FieldDefs.Add('contactName',ftstring,30);
    lbCustomerID.DataField := 'CustomerID';
    edCompanyName.DataField := 'CompanyName';
    edContactName.DataField := 'ContactName';
    WebClientConnection1.Active := True;
  except
    on E: Exception do
      WebMemo1.Lines.Add(E.Message);
  end;
end;

procedure TFormEmsDemo.WebClientConnection1BeforeConnect(Sender: TObject);
begin
  WebMemo1.Lines.Add('BeforeConnect');
end;

procedure TFormEmsDemo.WebClientConnection1AfterConnect(Sender: TObject);
begin
  WebMemo1.Lines.Add('AfterConnect');
end;

procedure TFormEmsDemo.WebClientConnection1ConnectError(Sender: TObject; ErrorCode: Integer);
begin
  WebMemo1.Lines.Add('ConnectError ' + IntToStr(ErrorCode));
end;

procedure TFormEmsDemo.WebClientDataSource1DataChange(Sender: TObject; Field: TField);
begin
  WebMemo1.Lines.Add('DataChange');
end;

procedure TFormEmsDemo.WebClientDataSource1StateChange(Sender: TObject);
begin
  WebMemo1.Lines.Add('StateChange');
end;

procedure TFormEmsDemo.WebClientDataSource1UpdateData(Sender: TObject);
begin
  if not TableUpdating then
  try
    TableUpdating := True;
    WebMemo1.Lines.Add('UpdateData');
    if WebClientDataSet1.State in dsEditModes then
    begin
      WebClientDataSet1.Post;
      WebMemo1.Lines.Add('Post');
    end;
    WebHttpRequest1.URL := 'https://www.bobswart.nl/ems/emsserver.dll/WebCoreEMS/UpdateCustomer' +
      '/' + lbCustomerID.Caption +
      '/' + edCompanyName.Text +
      '/' + edContactName.Text;
    WebHttpRequest1.URL := 'http://localhost:8080/WebCoreEMS/UpdateCustomer' + // local test
      '/' + lbCustomerID.Caption +
      '/' + edCompanyName.Text +
      '/' + edContactName.Text;
    WebMemo1.Lines.Add(WebHttpRequest1.URL);
    WebHttpRequest1.Execute;
  finally
    TableUpdating := False;
  end;
end;

end.
